TimeDicer: Changelog
====================

(For versions 8.0415 and earlier, date of change is shown by release number:y.mmdd i.e. 1.1216 is 16 Dec 2011)

8.15 [13 Feb 2026]
-----------------
TimeDicer.cmd   : Use api-version 201 syntax, other bugfixes

8.14 [26 Mar 2024]
-----------------
TimeDicer.cmd   : Change the references for Microsoft C++ 2008 Redistributables

8.13 [07 Nov 2022]
-----------------
TimeDicer.cmd   : Bugfix for saving server key

8.12 [25 Oct 2022]
-----------------
TimeDicer.cmd   : Minor update

8.11 [14 Sep 2020]
------------------
TimeDicer.cmd   : add -batch option to plink.exe (kudos: Christoph Langbein)

8.10 [14 Sep 2020]
------------------
TimeDicer.cmd   : Bugfix for a case where plink.exe is in a path containing spaces

8.09 [24 Jun 2020]
------------------
TimeDicer.cmd   : Allow different-named versions of rdiff-backup on client and/or server

8.0415
------
TimeDicer.cmd   : Bugfix handling of quotes

6.0404
------
TimeDicer.cmd   : Bugfix formatting of dates in output

6.0330
------
TimeDicer.cmd   : New error 19 if no valid sources could be found (if some
                  are missing but not others, no error occurs - by design).

5.0910
------
TimeDicer.cmd   : Work with Windows 10.0

5.0525
------
TimeDicer.cmd   : Fix bug which surfaced if there were spaces inside quotes in 
                  config files.

5.0412
------
TimeDicer.cmd   : Various bugs squashed. Command-line specification of source
                  directories and destination repositories has changed and is
                  now handled with /n switch.

5.0226
------
TimeDicer.cmd   : add many new command-line switches and the ability to specify
                  the source directories and repositories on the command-line.
                  This means it is possible to use TimeDicer.cmd without a
                  configuration file. If an excludelist is required however this
                  must still exist as a file.
                  Command-line switches must now be preceded by / (i.e. - is no
                  longer supported) and are now case-sensitive

install.bat    :  bugfixes, no longer make any registry entries

5.0214
------
TimeDicer.cmd   : prevent ssed error message re excludelist1.txt

4.1106
------
TimeDicer.cmd   : option 'skip-rdiff-backup-test' also skips testing for 
                  presence of server and of /home/tmp thereon; so
                  TimeDicer.cmd can work with server with
                  ssh login restricted to command 'rdiff-backup --server' by
                  means of line beginning 'command=' in user's 
                  .ssh/authorized_keys file.

4.0324
------
TimeDicer.cmd   : Better selection of default browser, work better if Cygwin is installed

3.1112
------
TimeDicer.cmd   : Minor bugfixes

3.1102
------
TimeDicer.cmd   : Work with Windows 8.1

2.1213
------
TimeDicer.cmd   : Work with Windows 8

2.1111
------
TimeDicer.cmd   : Fix to allow key of TimeDicer Server automatically

2.1104
------
TimeDicer.cmd   : Fix to allow browser to show log under Windows 7
                  at end of run if there was a problem

2.0219
------
TimeDicer.cmd   : Minor bugfixes

2.0130
------
TimeDicer.cmd   : Improved layout of log left-hand menu
timedice.css    : modified for improved log left-hand menu

2.0102
------
TimeDicer.cmd   : Modified handling of log display (new openhtml code)

2.0101
------
TimeDicer.cmd   : Modified wait behaviour after each call of rdiff-backup;
                  faster & prevents failure to write to log, which previously
                  gave rise to 'The process cannot access the file because
                  it is being used by another process' messages in a few cases

1.1231
------
TimeDicer.cmd   : Change in default behaviour regarding pause at end of run:
                  don't pause unless there is an error; with /x switch
                  behaviour is unchanged i.e. don't pause even on error

1.1226
------
TimeDicer.cmd   : Minor log/screen output change

1.1216
------
TimeDicer.cmd   : Fix bug in 1.1215 if privatekey filepath contained space
                  Prevent pausing of TimeDicer if an error log has to be shown
                  Fix log text for error 30
                  For new installations make '-v5' standard for 'SET options'

1.1215
------
TimeDicer.cmd   : Remove VSHADOW text that crept into the log at v1.1212
                  Create and show html log even when error occurs early in run

1.1212
------
TimeDicer.cmd   : Minor improvement to log output in case of error

1.1210
------
TimeDicer.cmd   : Bugfix - log or privatekey files with spaces in name
                  Bugfix - lines in config file with quote characters

1.1206
------
TimeDicer.cmd   : Minor improvements to log format

1.1205
------
TimeDicer.cmd   : Alter man page appearance
                  Add /d command-line option which forces deletion of 
                  pre-existing volume shadow sets
                  Deprecate 'deleteshadows' option in ConfigFile

1.1203
------
TimeDicer.cmd   : Bugfix for a new bug in 1.1202

1.1202
------
TimeDicer.cmd   : Minor bugfixes to log format

1.1201
------
TimeDicer.cmd   : Change logfile to html format, default logfile is now
                  '%APPDATA%\TimeDicer\timedicer-log.html'
                  Fix bug preventing saving of last backup date
install.bat     : Update putty, puttygen and plink to latest versions
                  Add menu links to log and to manual

1.1126
------
TimeDicer.cmd   : Change to logfile - run data added at top not bottom of file

1.1125
------
TimeDicer.cmd   : Bugfix (use netsh not ping for delay) + simplifications

1.1121
------
TimeDicer.cmd   : Bug with non-VSS use fixed, and some other small bugs

1.1023
------
TimeDicer.cmd   : Use --remote-tmp=/home/tmp if /home/tmp exists on server

1.0929
------
TimeDicer.cmd   : Minor change to log error reporting

1.0921a
-------
TimeDicer.cmd   : Important bug fix to report some errors which might
                  previously not have been reported.

1.0920
------
TimeDicer.cmd   : Change to default behaviour: existing shadow copies are no
                  longer automatically deleted before TimeDicer client starts
                  backup run. Use option SET deleteshadows=y (default n) to
                  restore the previous behaviour.

1.0916
------
TimeDicer.cmd   : New option SET deleteshadows=n (default y) skips automatic deletion
                  of any pre-existing shadow copies before commencing backup run.
                  Rename a lot of temporary files to give unique names so that
                  simultaneous runs of TimeDicer do not conflict.
                  Alter logging so that logs are appended to a single growing log file
                  instead of replacing it on each run.

1.0829
------
TimeDicer.cmd   : 3rd fix for exclude-filelist.txt references to primary source drive

1.0828
------
TimeDicer.cmd   : 2nd fix for exclude-filelist.txt references to primary source drive
                  allow environment variables in exclude-filelist.txt
                  add SET port= option

1.0825
------
TimeDicer.cmd   : fix for exclude-filelist.txt references to primary source drive

1.0824
------
TimeDicer.cmd   : fix failed exclude-filelist.txt references to primary source drive

1.0801
------
TimeDicer.cmd   : minor corrections to man page information

1.0307
------
TimeDicer.cmd   : bugfix for 64-bit Windows XP and 2003

1.0302
------
TimeDicer.cmd   : bugfix for exclude-filelist containing spaces

1.0222
------
server scripts  : timedicer-server-setup - install 'wakeonlan' which is needed
                  for timedicer-mirror

1.0219
------
server scripts  : timedicer-mirror - rsync was failing if LVM device was at
                  /root, also improved start-up messages re switches

1.0217
------
server scripts  : timedicer-server-setup - added installation of sshfs, also
                  auto-add new users to 'fuse' group
                : install-vmware-tools.sh - added this program to ease
                  installation of vmware tools and vmxnet for VMs

1.0216
------
server scripts  : timedicer-server-setup bugfix so that root rsa key is
                  created without passphrase

1.0214
------
server scripts  : fix rdiff-backup-fv (affects timedicer-verify and timedicer-
                  mirror) to work under 64-bit installations

1.0207
------
server scripts  : bugfixes for rdiff-backup-install, timedicer-verify,
                  timedicer-mirror and timedicer-server-setup

1.0130
------
TimeDicer.cmd   : show error message text when an error occurs, instead of
                  just referring user to man page

1.0120
------
TimeDicer.cmd & install.bat : change default location of privatekey.ppk to
                  %APPDATA%\TimeDicer (instead of %USERPROFILE%), but old
                  location is still supported

1.0118
------
TimeDicer.cmd   : restoring/listing made case-insensitive
                : add errors 17 and 18 for restore failure

0.1218
------
TimeDicer.cmd   : fix for backing up from root directory with VSS

0.1217
------
/opt/timedicer-server-setup : now installs 2 versions of rdiff-backup, the
                  standard 1.2.8, + a patched version supporting --verify-full
                  and --verify-full-since options. Patched rdiff-backup can
                  be used via /opt/rdiff-backup-fv.
/opt/rdiff-backup-install : changes for above
/opt/rdiff-web-install : renamed
/opt/rdiff-backup-fv : call rdiff-backup with --verify-full option.
/opt/rdiff-backup-regress : can regress repositories
/opt/timedicer-verify : full verification of all repositories on
                  TimeDicer Server, uses rdiff-backup-fv. Called automatically
                  by cron daily.
TimeDicer.cmd   : add new option 'SET skip-rdiff-backup-test=y'

0.1216
------
TimeDicer.cmd   : minor fixes for layout of TimeDicer-action.bat and for debug
                  messages

0.10.1215
---------
TimeDicer.cmd   : fixed bug if last switch on command line was not /f [2nd try]

0.10.1212
---------
TimeDicer.cmd   : fixed bug if last switch on command line was not /f

0.10.1211
---------
TimeDicer.cmd   : trivial changes to exit messages (to identify TimeDicer
                  version upon exit, especially if error occurs)

0.10.1210a
----------
TimeDicer.cmd   : fix a bug which prevented TimeDicer 0.1206+ detecting a
                  failed backup

0.10.1209
---------
TimeDicer.cmd   : removed sourcedrive option (for VSS snapshot), this is now
                  determined automatically at runtime

0.10.1208d
----------
TimeDicer.cmd   : update the manual page a little

0.10.1208b/c
------------
TimeDicer.cmd   : rename %TEMP%\exclfolders.linuxed timedicer-excludelist.txt
                : change test connection folder to %basearchive%

0.10.1208a
----------
TimeDicer.cmd   : rename %TEMP%\timedicer1.txt to timedicer-dataset.txt

0.10.1208
---------
TimeDicer.cmd   : in debug mode, don't pause before backup run if /x is set

0.10.1207a
----------
TimeDicer.cmd   : fix a new bug with if excludelist is undefined

0.10.1207
---------
TimeDicer.cmd   : fix a new bug with 'false' error 105 obtaining mdy

0.10.1206
---------
TimeDicer.cmd   : stop reporting a log file at end when there isn't one
                : revise mdy code to remove recursive call
                : fix error message regarding thischanges file
                : rewrite source expansion (exp_i) avoiding batch call
                : improved error checking (codes 130-139)
                : corrected log header if not using vss
                : trapped the 'cannot write to file.. another process' error
                  message
                : removed extraneous EOF at end of log file

0.10.1204a
----------
TimeDicer.cmd   : tiny bug fix
install.bat     : include timedicer.hta, the restore GUI. After installation,
                  right-click on a file and select 'TimeDicer' to see saved
                  versions, then select a version to recover it

0.10.1203
---------
TimeDicer.cmd   : bug fixes for previous versions 0.10.1130+, much improved
                  error handling

0.10.11301
----------
TimeDicer.cmd   : bug fixes for previous version

0.10.1130
---------
TimeDicer.cmd   : alter name of lastchangesfilelong so that separate info
                  can be retained for each user and configuration file. Also
                  allow datasets to be edited out of configuration file temp-
                  orarily and then added back without upsetting
                  skip_on_no_changes. Also tidy up log file a bit.
                : add restore and list functions (further testing required)

0.10.1129
---------
TimeDicer.cmd   : move temporary log files to %TEMP%, various changes to
                  logging, and show some backup progress on console
                  unless quiet is set
                : skip_on_no_change was not working - now it is

0.10.1125
---------
install.bat     : correction to default setup of configuration file:
                  SET excludelist= instead of SET exclude-filelist=

0.10.1124
---------
TimeDicer.cmd   : fix bug introduced in 0.10.1123 - rename exclude-filelist
                  option as excludelist to prevent confusion with rdiff-backup
                  option exclude-filelist. Note: excludelist option is
                  equivalent to rdiff-backup's exclude-globbing-filelist

0.10.1123
---------
TimeDicer.cmd   : alter variable exclude-globbing-filelist to exclude-filelist
                  (note: change in default behaviour)
                : add a test for definition of server in config file
                : improved interpretation of config file, allow comments at end
                  of lines and allow inset instructions
                : delayed variable expansion
                : new date reformatting code - nlsinfo.exe no longer needed
install.bat     : add exclude-filelist.txt to installation fileset
                  - and use it in initial config
                : alter initial backup set to a more realistic
                  usable backup i.e. %USERPROFILE%, not Desktop

0.10.1122
---------
TimeDicer.cmd	: fix problem if log is defined with quotes in config
		: remove extraneous spaces around '&&'
		: add /x option to skip pause at end
		    (note: change in default behaviour)
		: add /f option to specify ConfigFile, remove code which
		  merges configfiles (note: change in default behaviour)
		: add /g option for debug messages

0.10.1121
---------
TimeDicer.cmd	: improved error recognition
install.bat	: many fixes
